---
title: HTML Sanitizer API
slug: Web/API/HTML_Sanitizer_API
tags:
  - HTML Sanitizer API
  - Landing
  - Web API
  - santitize
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("HTML Sanitizer API")}}</div>

<p class="summary">The HTML Sanitizer API allow developers to take untrusted strings of HTML, and sanitize them for safe insertion into a document’s DOM.</p>

<h2 id="Sanitizer_API_Concepts_and_Usage">Sanitizer API Concepts and Usage</h2>

<p>Web applications often need to work with strings of HTML on the client side, perhaps as part of a client-side templating solution, perhaps as part of rendering user generated content. It is difficult to do so in a safe way. The Sanitizer API allows for rendering HTML in a safe manner.</p>

<p>To access the API you would use the constructor, which creates a {{domxref('Sanitizer.Sanitizer')}} instance and allows for a configurable list of allowed or dis-allowed elements and attributes.</p>

<p>The most common use-case - preventing XSS - is handled by the built-in default lists, so that creating a {{domxref('Sanitizer.Sanitizer')}} with a custom config is necessary only to handle additional, application-specific use cases.</p>

<p>The API has two methods to sanitize strings. One returns a string and the other returns a document fragment. See the <a href="#Examples">examples section below</a> for more.</p>

<h2 id="Sanitizer_API_Interfaces">Sanitizer API Interfaces</h2>

<dl>
 <dt>{{domxref('Sanitizer')}}</dt>
 <dd>The <strong><code>Sanitizer</code></strong> interface of the {{domxref('HTML Sanitizer API')}} provides the functionality to take untrusted strings of HTML, and sanitize them for safe insertion into a document’s DOM.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example shows the result of sanitizing a string using the {{domxref('Sanitizer.sanitizeToString()')}} method. A {{jsxref('String')}} is returned with disallowed <code>script</code> and <code>blink</code> elements removed.</p>

<pre class="brush: js notranslate">// our input string to clean
const stringToClean = 'Some text &lt;b&gt;&lt;i&gt;with&lt;/i&gt;&lt;/b&gt; &lt;blink&gt;tags&lt;/blink&gt;, including a rogue script &lt;script&gt;alert(1)&lt;/script&gt; def.';

const result = new Sanitizer().sanitizeToString(stringToClean);
console.log(result);
// Logs: "Some text &lt;b&gt;&lt;i&gt;with&lt;/i&gt;&lt;/b&gt; &lt;blink&gt;tags&lt;/blink&gt;, including a rogue script def."
</pre>

<p>The other method available is the {{domxref('Sanitizer.sanitize()')}} method. Which is very similar to above, however returns a {{domxref('DocumentFragment')}} with disallowed <code>script</code> and <code>blink</code> elements removed.</p>

<pre class="brush: js notranslate">// our input string to clean
const stringToClean = 'Some text &lt;b&gt;&lt;i&gt;with&lt;/i&gt;&lt;/b&gt; &lt;blink&gt;tags&lt;/blink&gt;, including a rogue script &lt;script&gt;alert(1)&lt;/script&gt; def.';

const result = new Sanitizer().sanitize(stringToClean);
// Result: A DocumentFragment containing text nodes and a &lt;b&gt; element, with a &lt;i&gt; child element
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML Sanitizer API','#sanitizer-api','sanitizeToString')}}</td>
   <td>{{Spec2('HTML Sanitizer API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Sanitizer")}}</p>
